//#include <iostream.h>
#include "vector.h"

int main(int argc, char** argv)
{
  VECTOR4D vA = {1, 2, 3, 4};
  VECTOR4D vB = {5, 6, 7, 8};
  Vector u, v, w; // Vectors
  FLOAT f;        // Scalars
  BOOL b;         // Booleans

//  cout<<"Hello World";

  u.Null();
  v.Set(vA);
  w.Set(vB);

  f = v[0];       // LHS Index Operation
  printf("  f = v[0];\n");
  printf("%.3f = %.3f\n", f, v[0]);
  v[0] = 0;
  printf("v[0] = %.3f\n", v[0]);
  v[0] = f;       // LHS Index Operation
  printf("  v[0] = f;       // LHS Index Operation\n");
  printf("%.3f = %.3f\n", v[0], f);
  f = v(0);       // RHS Index Operation
  printf("  f = v(0);       // RHS Index Operation\n");
  printf("%.3f = %.3f\n", f, v[0]);
  //v(0) = f;       // ILLEGAL -- RHS (right hand side) only!!!
  printf("  //v(0) = f;       // ILLEGAL -- RHS (right hand side) only!!!\n");
 
  u.Null();
  printf("u = ");
  u.Display();
  u = v;
  printf("  u = v;\n");
  printf("u = ");
  u.Display();
  u += v;
  printf("  u += v;\n");
  printf("u = ");
  u.Display();
  u -= v;
  printf("  u -= v;\n");
  printf("u = ");
  u.Display();
  f = 2.0;
  u *= f;         // Scalar Multiplication
  printf("  u *= f;         // Scalar Multiplication\n");
  printf("f = %f u = ", f);
  u.Display();
  u = -v;
  printf("  u = -v;\n");
  printf("u = ");
  u.Display();
  u = v + w;
  printf("  u = v + w;\n");
  printf("u = ");
  u.Display();
  u = v - w;
  printf("  u = v - w;\n");
  printf("u = ");
  u.Display();
  u = v * w;      // Cross Product
  printf("  u = v * w;      // Cross Product\n");
  u = v.Cross(w); // Cross Product
  printf("  u = v.Cross(w); // Cross Product\n");
  f = v.Dot(w);   // Dot Product
  printf("  f = v.Dot(w);   // Dot Product\n");
  printf("u = ");
  u.Display();
  u = v * f;      // Scalar Multiplication
  printf("  u = v * f;      // Scalar Multiplication\n");
  printf("u = ");
  u.Display();
  u = f * v;      // Scalar Multiplication
  printf("  u = f * v;      // Scalar Multiplication\n");
  printf("u = ");
  u.Display();
  u = v / f;      // Scalar Division
  printf("  u = v / f;      // Scalar Division\n");
  printf("u = ");
  u.Display();
 
  // Logic
  b = (u == v);   // Quasi Equal allows for floating point inaccuracy
  printf("  b = (u == v);   // Quasi Equal allows for floating point inaccuracy\n");
  b = (u != v);   // Quasi Not Equal allows for floating point inaccuracy
  printf("  b = (u != v);   // Quasi Not Equal allows for floating point inaccuracy\n");

  return 0;
}
