#include "slidenode.h"

#include "slideworld.h"
#include "slideface.h"

BOOL CSLIDENode::m_bRenderBound = FALSE;
BOOL CSLIDENode::m_bColorDynamicBounds = FALSE;
BOOL CSLIDENode::m_bBoundReject = TRUE;

//////////////////////////////////////////////////////////////////////
// CSLIDENode Class
//

CSLIDENode::CSLIDENode()
{
}

CSLIDENode::~CSLIDENode()
{
}

VOID CSLIDENode::Init(CHAR *pcFile, UINT_32 uiLine, UINT_32 uiColumn, CHAR *pcID)
{
  CSLIDEPrimitive::Init(pcFile, uiLine, uiColumn, pcID);
}

VOID CSLIDENode::Uninit()
{
  CSLIDEPrimitive::Uninit();
}

BOOL CSLIDENode::Initialized()
{
  return CSLIDEPrimitive::Initialized();
}

BOOL CSLIDENode::CheckSemantics(CSLIDEWorld *pCSLIDEWorld)
{
  return CSLIDEPrimitive::CheckSemantics(pCSLIDEWorld);
}

BOOL CSLIDENode::Valid()
{
  return CSLIDEPrimitive::Valid();
}

VOID CSLIDENode::PreprocessGraph()
{
  SetBounded(FALSE);
  SetBoundDynamic(FALSE);
  SetBoundValid(TRUE);
  SetBoundChanged(FALSE);
}

VOID CSLIDENode::UpdateGraph()
{
}

VOID CSLIDENode::InsertIntoBound(const Matrix &/*m*/, CBound &/*bound*/)
{
  // This is the right thing to do for nodes with no bounds
  // like cameras and lights
}

VOID CSLIDENode::CalculateBound()
{
}

/*
CSLIDECamera *CSLIDENode::FindCamera(const Matrix &m, PATH )
{
}

CSLIDEPoint *CSLIDENode::FindPoint(const Matrix &m, PATH )
{
}
*/

//////////////////////////////////////////////////////////////////////////////
// START: ASSIGNMENT 4: Consider LOD and Bounding Box Culling
// 
// This gets called for Objects and Groups
// If clip bound no longer needs to be considered you might pass a 
// Null pointer for pCBoundClip
//
VOID CSLIDENode::Render(const Matrix &mGvp_proj, 
			const Matrix &mGproj_vrc, const Matrix &mGvrc_proj, 
			const Matrix &mGvrc_obj, const Matrix &mGobj_vrc, 
			CBound *pCBoundClip, 
			CListInt *plistLights,
			CSLIDESurface *pCSLIDESurface,
			SLIDEShadingType eShading, 
			SLIDELODType eLOD)
{
  CBound::BoundIntersectionType eIntersect;

  ModifySurfacePointer(pCSLIDESurface);
  ModifyLODFlag(eLOD);

  // Check for Bound Rejection????

  RenderGeometry(mGvp_proj, mGproj_vrc, mGvrc_proj, 
		 mGvrc_obj, mGobj_vrc, 
		 pCBoundClip, plistLights, pCSLIDESurface, 
		 eShading, eLOD);

  if ( GetRenderBound() )
    {
      RenderBound(mGvp_proj, mGproj_vrc, mGvrc_obj);
    }
}
// 
// END  : ASSIGNMENT 4: Consider LOD and Bounding Box Culling
//////////////////////////////////////////////////////////////////////////////

VOID CSLIDENode::ModifySurfacePointer(CSLIDESurface* &/*pCSLIDESurface*/)
{
}

VOID CSLIDENode::ModifyShadingFlag(SLIDEShadingType &/*eShading*/)
{
}

VOID CSLIDENode::ModifyLODFlag(SLIDELODType &/*eLOD*/)
{
}

CBound::BoundIntersectionType CSLIDENode::CheckBoundReject(const Matrix &/*m*/,
						        CBound * /*pCBoundClip*/)
{
  // Default to not doing any rejections
  return CBound::bitIntersect;
}

VOID CSLIDENode::RenderGeometry(const Matrix &/*mGvp_proj*/, 
				const Matrix &/*mGproj_vrc*/, 
				const Matrix &/*mGvrc_proj*/, 
				const Matrix &/*mGvrc_obj*/, 
				const Matrix &/*mGobj_vrc*/, 
				CBound * /*pCBoundClip*/, 
				CListInt * /*plistLights*/,
				CSLIDESurface * /*pCSLIDESurface*/,
				SLIDEShadingType /*eShading*/, 
				SLIDELODType /*eLOD*/)
{
}

VOID CSLIDENode::RenderBound(const Matrix &/*mGvp_proj*/, 
			     const Matrix &/*mGproj_vrc*/, 
			     const Matrix &/*mGvrc_obj*/)
{
}


